/**
  ******************************************************************************
  * @file    Project/main.c 
  * @author  MCD Application Team
  * @version V2.1.0
  * @date    18-November-2011
  * @brief   Main program body
  ******************************************************************************
  * @attention
  *
  * THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
  * WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE
  * TIME. AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY
  * DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
  * FROM THE CONTENT OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE
  * CODING INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
  *
  * <h2><center>&copy; COPYRIGHT 2011 STMicroelectronics</center></h2>
  ******************************************************************************
  */ 
//ʱ̵ ִϴ 20150426

/* Includes ------------------------------------------------------------------*/
#include "stm8s.h"
#include "led.h"        //һЩIOڵĶ

/* Private defines -----------------------------------------------------------*/
unsigned char CODE[10] = {0x3f,0x06,0x5b,0x4f,0x66,0x6d,0x7d,0x07,0x7f,0x6f};
unsigned char show[4];
unsigned char show_mie[4]={0,0,0,0};
  
unsigned long  TimingDelay=0;
unsigned long  TimingNewTrig=0; 

INT16_memory    memory;
unsigned long time_t1=0;
unsigned long time_t2=0;
unsigned int  Nx_count=0;

unsigned char TRIG_OK = 0 ;
unsigned char STRAT_OK = 0 ; 

unsigned char MODESET_OK = 0;
unsigned char SET_OK = 0;
unsigned char ADD_OK = 0;
unsigned char DEC_OK = 0;

/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/


void init_GPIO(void)
{
  //ledָʾųʼ
   GPIO_Init(LED1_GPIO_PORT, (GPIO_Pin_TypeDef)LED1_GPIO_PINS, GPIO_MODE_OUT_PP_LOW_FAST);
   GPIO_Init(LED2_GPIO_PORT, (GPIO_Pin_TypeDef)LED2_GPIO_PINS, GPIO_MODE_OUT_PP_LOW_FAST);
  //ܿųʼ
   GPIO_Init(TM1620_STB_GPIO_PORT, (GPIO_Pin_TypeDef)TM1620_STB_GPIO_PINS, GPIO_MODE_OUT_PP_LOW_FAST);  
   GPIO_Init(TM1620_CLK_GPIO_PORT, (GPIO_Pin_TypeDef)TM1620_CLK_GPIO_PINS, GPIO_MODE_OUT_PP_LOW_FAST);
   GPIO_Init(TM1620_DIN_GPIO_PORT, (GPIO_Pin_TypeDef)TM1620_DIN_GPIO_PINS, GPIO_MODE_OUT_PP_LOW_FAST);
   
   //밴ΪģʽΪ½شж--Ϊʱһ͵ƽ
    GPIO_Init(KEY_SET_GPIO_PORT, KEY_SET_GPIO_PINS, GPIO_MODE_IN_PU_IT);
    
    GPIO_Init(KEY_ADD_GPIO_PORT, KEY_ADD_GPIO_PINS, GPIO_MODE_IN_PU_IT);
    
    GPIO_Init(KEY_DEC_GPIO_PORT, KEY_DEC_GPIO_PINS, GPIO_MODE_IN_PU_IT);
    
    EXTI_SetExtIntSensitivity(EXTI_PORT_GPIOC, EXTI_SENSITIVITY_FALL_ONLY);
    
   //룬ųʼ
   GPIO_Init(INT_GPIO_PORT, INT_GPIO_PINS, GPIO_MODE_IN_FL_IT);
   EXTI_SetExtIntSensitivity(EXTI_PORT_GPIOB, EXTI_SENSITIVITY_RISE_ONLY);
       
   GPIO_Init(OUT_GPIO_PORT, OUT_GPIO_PINS, GPIO_MODE_OUT_PP_LOW_FAST);  
  
}

/*******************************************************************************
 * : Tim1_Init
 * : TIM1ʼ
 * β: 
 * : 
 * ˵:  
 ******************************************************************************/
void Tim1_Init(void)
{
  	/* ʼTIM1Ϊⲿʱ24Ƶ ϼģʽ 1000 ʼֵ0 -- 1msһж*/
	TIM1_TimeBaseInit(15, TIM1_COUNTERMODE_UP, 999, 0);
	TIM1_SetCounter(0);/* ֵΪ0 */
	TIM1_ARRPreloadConfig(DISABLE);	/* Ԥװزʹ */
	TIM1_ITConfig(TIM1_IT_UPDATE , ENABLE);	/* ϼ/¼ж */
	TIM1_Cmd(ENABLE);			/* ʹTIM1 */
}


/*********************************   
ܣ TM1620д
**********************************/
void TM1620_write(unsigned char wr_data)
{
     unsigned char i;
	TM1620_STB_0;	   //ЧƬѡźţƬѡźǵ͵ƽЧ
	 Delay(100);	 
	 for(i=0;i<8;i++)//ʼ8λݣÿѭһδһλ
	 {
	     TM1620_CLK_0;
             Delay(100);
             if(wr_data & 0x01) TM1620_DIN_1;
             else TM1620_DIN_0;
	     wr_data >>= 1;     //λݣλǰ!
             Delay(100);
             TM1620_CLK_1;
             Delay(100);
	   }
}

/*********************************
    TM1620ָ
ܣ LEDӦʾ
**********************************/
void xianshi(unsigned char show_led[4])
{
  unsigned char h;
  TM1620_STB_1;
  TM1620_CLK_1;
  TM1620_DIN_1;
    Delay(100);
  TM1620_write(0x02);//ʾģʽãΪ6GRID8SEG
  TM1620_STB_1;
    Delay(100);
  TM1620_write(0x40);//дݵʾĴõַԶһ
  TM1620_STB_1;
    Delay(100);
  TM1620_write(0xc0);//ʾĴ00HԪʼ
  for(h=0;h<4;h++)
  {    
   TM1620_write(show_led[h]);//ʾĴݣ
   TM1620_write(0x00);
   }
  
   TM1620_STB_1;
    Delay(100);
   TM1620_write(0x8b);//ʾƲĻȿͨıλ
}

/*********************************
ܣ ʾ
**********************************/

void Play_data()
{
  
    show[0] = CODE[ memory.set_count];
    switch( memory.set_count)
    {
    case 1:
      show[1] = 0x00;
      show[2] = CODE[ memory.set_mode / 10];
      show[3] = CODE[ memory.set_mode % 10] ;
      break;
    case 2:
      show[1] = CODE[ memory.T1x / 100];
      show[2] = CODE[ memory.T1x  /10 %10];
      show[3] = CODE[ memory.T1x % 10];
      break;
    case 3:
      show[1] = CODE[ memory.T1b / 100];
      show[2] = CODE[ memory.T1b /10 %10] | 0x80;
      show[3] = CODE[ memory.T1b % 10] ;
      break;
    case 4:
      show[1] = CODE[ memory.T2x / 100];
      show[2] = CODE[ memory.T2x /10 %10];
      show[3] = CODE[ memory.T2x % 10] ;
      break;
    case 5:
      show[1] = CODE[ memory.T2b / 100];
      show[2] = CODE[ memory.T2b /10 %10] | 0x80;
      show[3] = CODE[ memory.T2b % 10] ;
      break;
    case 6:
      show[1] = CODE[ memory.Nx / 100];
      show[2] = CODE[ memory.Nx/ 10 %10];
      show[3] = CODE[ memory.Nx % 10] ;
      break;
    default:
      break;                         
    }
    
    //ģʽɽ˸
    if (MODESET_OK ) 
    {   
      static unsigned char i;
      static unsigned long lasttime=0;
    
      
      if( TimingDelay - lasttime >=100 ) 
        
      {
         lasttime = TimingDelay ;
         i=!i;
      }
      
      
      if( i )       xianshi( show_mie ); 
      else  xianshi(show);
      
    }
    //ǹģʽܳ
    else     xianshi(show); 
   
}

/*********************************
ܣ ݲ洢ʼ
**********************************/

void FLASH_Config(void)
{
 /* Define flash programming Time*/
  FLASH_SetProgrammingTime(FLASH_PROGRAMTIME_STANDARD);

  FLASH_Unlock(FLASH_MEMTYPE_PROG);
  /* Wait until Flash Program area unlocked flag is set*/
  while (FLASH_GetFlagStatus(FLASH_FLAG_PUL) == RESET)
  {}

}

/*********************************
ܣ õֵ
**********************************/
 void  Write_memory(void)
 {
   
    unsigned char buf[14];
    static unsigned long lasttime=0;
    
     if( TimingDelay - lasttime >=1000 )
     {
       
    lasttime = TimingDelay ;
    
    buf[0] =BYTE_0( memory.set_count);
    buf[1] =BYTE_1( memory.set_count);
    buf[2] =BYTE_0( memory.set_mode);
    buf[3] =BYTE_1( memory.set_mode); 
    buf[4] =BYTE_0( memory.T1x);
    buf[5] =BYTE_1( memory.T1x);
    buf[6] =BYTE_0( memory.T1b); 
    buf[7] =BYTE_1( memory.T1b); 
    buf[8] =BYTE_0( memory.T2x); 
    buf[9] =BYTE_1( memory.T2x);
    buf[10] =BYTE_0( memory.T2b);
    buf[11] =BYTE_1( memory.T2b);
    buf[12] =BYTE_0( memory.Nx);
    buf[13] =BYTE_1( memory.Nx);
        
   FLASH_Unlock(FLASH_MEMTYPE_DATA);
   FLASH_ProgramByte(0x40A0,buf[0]);
   FLASH_ProgramByte(0x40A1,buf[1]);    
   FLASH_ProgramByte(0x40A2,buf[2]);
   FLASH_ProgramByte(0x40A3,buf[3]);        
   FLASH_ProgramByte(0x40A4,buf[4]);
   FLASH_ProgramByte(0x40A5,buf[5]);        
   FLASH_ProgramByte(0x40A6,buf[6]);
   FLASH_ProgramByte(0x40A7,buf[7]);      
   FLASH_ProgramByte(0x40A8,buf[8]);
   FLASH_ProgramByte(0x40A9,buf[9]);        
   FLASH_ProgramByte(0x40AA,buf[10]);
   FLASH_ProgramByte(0x40AB,buf[11]);        
   FLASH_ProgramByte(0x40AC,buf[12]);
   FLASH_ProgramByte(0x40AD,buf[13]);        
   FLASH_Lock(FLASH_MEMTYPE_DATA);
     }

 }

/*********************************
ܣ ȡǰֵ
**********************************/

 void  Read_memory(void)
 {
    unsigned char i=0;
    unsigned int buf[14];
    for(i=0;i<14;i++)
      {
        buf[i] = FLASH_ReadByte(0x40A0+i);
      }
    memory.set_count = buf[1] <<8 | buf[0];
    memory.set_mode  = buf[3] <<8 | buf[2];
    memory.T1x = buf[5] <<8 | buf[4];
    memory.T1b = buf[7] <<8 | buf[6];
    memory.T2x = buf[9] <<8 | buf[8];
    memory.T2b = buf[11] <<8 | buf[10];
    memory.Nx  = buf[13] <<8 | buf[12];
 }

/*********************************
ܣ ̵ģʽִ
**********************************/    
void Play_mode(void)
{
  
    time_t1 = (long)memory.T1x * memory.T1b *100 ;
    time_t2 = (long)memory.T2x * memory.T2b *100 ;
    
   switch( memory.set_mode)
      {
      //һʱϣϵʱT1ʱ̵ϣT10.1-27Сʱ֮ɵTRIGӿһ͵ƽźţظһϹܣ
      case 1:                  
          {
              
             if ( TRIG_OK )
              {
                TimingNewTrig = TimingDelay; 
                TRIG_OK = 0;
              }
             if( TimingDelay - TimingNewTrig >= time_t1 )  jdq_xihe ;
             else jdq_duankai ;                       
          }
         break;
      //ܶʱϿϵʱ̵ϣʱT1ʱ̵ϿT10.1-27Сʱ֮ɵTRIGӿһ͵ƽźţظһϹܣ  
      case 2:
        {
             if ( TRIG_OK )
              {
                TimingNewTrig = TimingDelay; 
                TRIG_OK = 0;
              }
             if( TimingDelay - TimingNewTrig >= time_t1 ) jdq_duankai;
             else jdq_xihe;                       
          }
          break;
      //ʱٶϿϵ󣬼̵ȲϣʱʱT1̵ϣ
      //ʱT2̵ϿʱʱT1T20.1-27Сʱ֮ɵTRIGӿһ͵ƽźţظһϹܣ  
      case 3:
        {
             if ( TRIG_OK )
              {
                TimingNewTrig = TimingDelay; 
                TRIG_OK = 0;
              }
             
             if( TimingDelay - TimingNewTrig >= time_t1 ) 
              {
                 if ( TimingDelay - TimingNewTrig >= time_t1 + time_t2 ) jdq_duankai;
                 else jdq_xihe;
              }
             else jdq_duankai  ;                       
          }
          break;    
          
       //ģʱϿϣϵ󣬼̵ϣʱʱT1̵Ͽ
       // ϿʱT2̵ϣʱʱT1T20.1-27Сʱ֮ɵTRIGӿһ͵ƽźţظһϹܣ
      case 4:
        {
             if ( TRIG_OK )
              {
                TimingNewTrig = TimingDelay; 
                TRIG_OK = 0;
              }
             
             if( TimingDelay - TimingNewTrig >= time_t1 ) 
              {
                 if ( TimingDelay - TimingNewTrig >= time_t1 + time_t2 ) jdq_xihe;
                 else jdq_duankai;
              }
             else jdq_xihe  ;                       
          }
          break;   
         
        //壺ѭʱģʽ1ϵ󣬼̵ȲϣʱʱT1̵ϣ
        //ʱT2̵ϿȻظ״̬,ʱʱT1T20.1-27СʱСʱ֮ɵ
        case 5:
        {
             if ( TRIG_OK )
              {
                TimingNewTrig = TimingDelay; 
                TRIG_OK = 0;
              }
             
             if( TimingDelay - TimingNewTrig >= time_t1 ) 
              {
                 if ( TimingDelay - TimingNewTrig >= time_t1 + time_t2 ) 
                  {
                   jdq_duankai;
                   TRIG_OK=1;
                  }
                 else jdq_xihe;
              }
             else jdq_duankai  ;                       
          }
          break;   
          
        //ѭʱģʽ2ϵ󣬼̵ϣʱʱT1̵Ͽ
        //ϿʱT2̵ϣȻظ״̬,ʱʱT1T20.1-27Сʱ֮ɵ
        case 6:
        {
          
             if ( TRIG_OK )
              {
                TimingNewTrig = TimingDelay; 
                TRIG_OK = 0;
              }
             
             if( TimingDelay - TimingNewTrig >= time_t1 ) 
              {
                 if ( TimingDelay - TimingNewTrig >= time_t1 + time_t2 ) 
                  {
                   jdq_xihe;
                   TRIG_OK=1;
                  }
                 else jdq_duankai;
              }
             else  jdq_xihe   ;                       
          }
          break;   
          
        //ߣѭʱģʽ1ϵ󣬼̵ȲϣʱʱT1̵ϣʱT2̵ϿȻظNX״̬
        //ʱT1T20.1-27Сʱ֮ɵѭNX1-999֮ɵTRIGӿһ͵ƽźţ¿ʼϹܣ
        case 7:
        {
             if ( TRIG_OK )
              {
                Nx_count  =memory.Nx;              
                TRIG_OK = 0;
              }
             
             if( TimingDelay - TimingNewTrig >= time_t1 ) 
              {
                 if ( TimingDelay - TimingNewTrig >= time_t1 + time_t2 ) 
                  {
                     jdq_duankai;            
                     if( Nx_count >1 )
                     {
                       Nx_count-- ;
                      TimingNewTrig = TimingDelay;  
                      }
                    }
                  else jdq_xihe;
              }
             else jdq_duankai  ;                       
          }
          break;  
          
         //ܰˣѭʱģʽ2ϵ󣬼̵ϣʱʱT1̵ϿϿʱT2̵ϣ
          //ȻظNX״̬ʱT1T20.1-27Сʱ֮ɵѭNX1-999֮ɵ,TRIGӿһ͵ƽźţ¿ʼϹܣ
        case 8:
        {
             if ( TRIG_OK )
              {
                Nx_count  =memory.Nx;              
                TRIG_OK = 0;
              }
             
             if( TimingDelay - TimingNewTrig >= time_t1 ) 
              {
                 if ( TimingDelay - TimingNewTrig >= time_t1 + time_t2 ) 
                  {
                     jdq_xihe;            
                     if( Nx_count >1 )
                     {
                       Nx_count-- ;
                      TimingNewTrig = TimingDelay;  
                      }
                    }
                  else jdq_duankai;
              }
             else jdq_xihe  ;                       
          }
          break; 
          
      //ܾţ̵ģʽ̵TRIGӿһ͵ƽźţ̵ϣٸһ͵ƽźż̵Ͽ
      case 9:                  
          {
            
             if ( TRIG_OK )
              {
                TRIG_OK = 0;              
                jdq_qufan ;
                while( ! GPIO_ReadInputPin(INT_GPIO_PORT, INT_GPIO_PINS));
              }                  
          }
         break;
         
       //ʮ̵ģʽʱϿܣϵ̵TRIGӿһ͵ƽźţ̵ϣCH1źʧ󣬼̵Ȼϣ
        // ʱT1̵ϿʱT10.1-27Сʱ֮ɵ
         //  ע⣺УT1Ϊ0룬ͱΪCH1е͵ƽźż̵ϣźϿ

      case 10:                  
          {
            
             if ( TRIG_OK )
              {
                 if ( ! GPIO_ReadInputPin(INT_GPIO_PORT, INT_GPIO_PINS))
                  {
                    TimingNewTrig = TimingDelay; 
                    TRIG_OK = 0;
                  }
                 jdq_xihe;
              } 
             
             else
             {
              if( TimingDelay - TimingNewTrig >= time_t1 )  jdq_duankai;
             }
           
          }
         break;
  
                      
       //ʮһʱϣϵ̵TRIGӿһ͵ƽźţʱT1ʱ̵ϣT100.1-27Сʱ֮ɵ
         //ظTRIGӿһ͵ƽźţظһϹܣ
         
      case 11 :                  
          {
             if ( STRAT_OK )
               
             {
      
                  if ( TRIG_OK )
                  {
                    TimingNewTrig = TimingDelay; 
                    TRIG_OK = 0;
                   }
                  
                 if( TimingDelay - TimingNewTrig >= time_t1 )  jdq_xihe ;
                 else jdq_duankai ;
            
              }
          }
             break;
             
         //ʮʱϿϵ̵TRIGӿһ͵ƽźţ̵ϣ
          //ʱT1ʱ̵ϿT10.1-27Сʱ֮ɵʱʱظTRIGӿһ͵ƽźţʱʱ¼ʱ
      case 12 :                  
          {
            
             if ( STRAT_OK )
               
             {    
                  if ( TRIG_OK )
                  {
                    TimingNewTrig = TimingDelay; 
                    TRIG_OK = 0;
                  }
                 if( TimingDelay - TimingNewTrig >= time_t1 )  jdq_duankai  ;
                 else jdq_xihe ;
             }
          }
                
            
             break;
           
       //ʮϵ̵TRIGӿһ͵ƽźţʱʱT1̵ϣ
             //ʱT2̵ϿʱʱT1T20.1-27Сʱ֮ɵظTRIGӿһ͵ƽźţظһϹܣ
      case 13:
        {
          
          if ( STRAT_OK )
               
             {
               
             if ( TRIG_OK )
              {
                TimingNewTrig = TimingDelay; 
                TRIG_OK = 0;
              }
             
             if( TimingDelay - TimingNewTrig >= time_t1 ) 
              {
                 if ( TimingDelay - TimingNewTrig >= time_t1 + time_t2 ) jdq_duankai;
                 else jdq_xihe;
              }
             else jdq_duankai  ;                       
          }
        }
          break;    
          
       //ʮģʱϿϣϵ̵TRIGӿһ͵ƽźţ̵ϣʱʱT1̵Ͽ
          //ϿʱT2̵ϣʱʱT1T2 0.1-27Сʱ֮ɵظTRIGӿһ͵ƽźţظһϹܣ
      case 14:
        {
             if ( STRAT_OK )
               
             {
               
             if ( TRIG_OK )
              {
                TimingNewTrig = TimingDelay; 
                TRIG_OK = 0;
              }
             
             if( TimingDelay - TimingNewTrig >= time_t1 ) 
              {
                 if ( TimingDelay - TimingNewTrig >= time_t1 + time_t2 ) jdq_xihe;
                 else jdq_duankai;
              }
             else jdq_xihe  ;                       
          }
        }
          break;   
         
        //ʮ壺ѭʱģʽ1ϵ̵TRIGӿһ͵ƽźţʱʱT1̵ϣʱT2̵Ͽ
          //Ȼظ״̬,ʱʱT1T20.1-27Сʱ֮ɵظTRIGӿһ͵ƽźţ¿ʼϹܣ
        case 15:
        {
          if ( STRAT_OK )
               
             {
             if ( TRIG_OK )
              {
                TimingNewTrig = TimingDelay; 
                TRIG_OK = 0;
              }
             
             if( TimingDelay - TimingNewTrig >= time_t1 ) 
              {
                 if ( TimingDelay - TimingNewTrig >= time_t1 + time_t2 ) 
                  {
                   jdq_duankai;
                   TRIG_OK=1;
                  }
                 else jdq_xihe;
              }
             else jdq_duankai  ;                       
          }
        }
          break;   
          
        //ʮѭʱģʽ2ϵ̵TRIGӿһ͵ƽźţ̵ϣ
       //   ʱʱT1̵ϿϿʱT2̵ϣȻظ״̬,ʱʱT1T20.1-27Сʱ֮ɵ
          //  ظTRIGӿһ͵ƽźţ¿ʼϹܣ
        case 16:
        {
         if ( STRAT_OK )
               
             {
             if ( TRIG_OK )
              {
                TimingNewTrig = TimingDelay; 
                TRIG_OK = 0;
              }
             
             if( TimingDelay - TimingNewTrig >= time_t1 ) 
              {
                 if ( TimingDelay - TimingNewTrig >= time_t1 + time_t2 ) 
                  {
                   jdq_xihe;
                   TRIG_OK=1;
                  }
                 else jdq_duankai;
              }
             else  jdq_xihe   ;                       
          }
        }
          break;   
          
        //ʮߣѭʱģʽ1ϵ̵TRIGӿһ͵ƽźţʱʱT1̵ϣ
          //ʱT2̵ϿȻظNX״̬ʱT1T20.1-27Сʱ֮ɵѭNX1-999֮ɵ
          //ظTRIGӿһ͵ƽźţ¿ʼϹܣ
        case 17:
        {
            if ( STRAT_OK )
               
             {
             if ( TRIG_OK )
              {
                Nx_count  =memory.Nx;              
                TRIG_OK = 0;
              }
             
             if( TimingDelay - TimingNewTrig >= time_t1 ) 
              {
                 if ( TimingDelay - TimingNewTrig >= time_t1 + time_t2 ) 
                  {
                     jdq_duankai;            
                     if( Nx_count >1 )
                     {
                       Nx_count-- ;
                      TimingNewTrig = TimingDelay;  
                      }
                    }
                  else jdq_xihe;
              }
             else jdq_duankai  ;                       
          }
        }
          break;  
          
         //ʮˣѭʱģʽ2ϵ̵TRIGӿһ͵ƽźţ̵ϣʱʱT1̵Ͽ
          //ϿʱT2̵ϣȻظNX״̬ʱT1T20.1-27Сʱ֮ɵѭNX1-999֮ɵ
          //ظTRIGӿһ͵ƽźţ¿ʼϹܡ
        case 18:
        {
         if ( STRAT_OK )
               
             {
             if ( TRIG_OK )
              {
                Nx_count  =memory.Nx;              
                TRIG_OK = 0;
              }
             
             if( TimingDelay - TimingNewTrig >= time_t1 ) 
              {
                 if ( TimingDelay - TimingNewTrig >= time_t1 + time_t2 ) 
                  {
                     jdq_xihe;            
                     if( Nx_count >1 )
                     {
                       Nx_count-- ;
                      TimingNewTrig = TimingDelay;  
                      }
                    }
                  else jdq_duankai;
              }
             else jdq_xihe  ;                       
          }
       
      }
         break; 
      }
}

/*********************************
ܣ ̵ģʽɨ谴
**********************************/
void Play_key(void)
{
  
  static unsigned long TimingNewKey_set=0; 
  static unsigned long TimingNewKey_add=0; 
  static unsigned long TimingNewKey_dec=0; 
  
  
  //ð
   if (!GPIO_ReadInputPin(KEY_SET_GPIO_PORT, KEY_SET_GPIO_PINS))
  {
       
      if (SET_OK)
      {        
          if (TimingDelay - TimingNewKey_set  >= 2000 )
          {
            MODESET_OK = ! MODESET_OK ;
            if( ! MODESET_OK ) memory.set_count-- ;
            SET_OK = 0 ;
          }
          
      }
  }
  else  TimingNewKey_set = TimingDelay; 
  
  if( MODESET_OK  )  led1_liang;
  else led1_mie;
  //
  

  //Ӱ
  if (!GPIO_ReadInputPin(KEY_ADD_GPIO_PORT, KEY_ADD_GPIO_PINS))
  {
       
      if (ADD_OK)
      {
         
          ADD_OK = 0 ;
         TimingNewKey_add = TimingDelay; 
      }
      
      if (TimingDelay - TimingNewKey_add  >= 1000 )
      {
         switch( memory.set_count)
                    {
                    case 1:
                       memory.set_mode++;
                       if ( memory.set_count ==19 )  memory.set_count=1;
                      break;
                    case 2:
                       memory.T1x++;
                      break;
                    case 3:
                       memory.T1b++;
                      break;
                    case 4:
                       memory.T2x++;
                      break;
                    case 5:
                       memory.T2b++;
                      break;
                    case 6:
                       memory.Nx++;
                      break;
                    default:
                      break; 
                    }
      }
  }
  else  TimingNewKey_add = TimingDelay; 
  //
  
  //ǼС
  if (!GPIO_ReadInputPin(KEY_DEC_GPIO_PORT, KEY_DEC_GPIO_PINS))
  {
       
      if (DEC_OK)
      {
         
          DEC_OK = 0 ;
         TimingNewKey_dec = TimingDelay; 
      }
      
      if (TimingDelay - TimingNewKey_dec  >= 1000 )
      {
         switch( memory.set_count)
                    {
                    case 1:
                       memory.set_mode --;
                       if ( memory.set_count ==19 )  memory.set_count=1;
                      break;
                    case 2:
                       memory.T1x --;
                      break;
                    case 3:
                       memory.T1b --;
                      break;
                    case 4:
                       memory.T2x --;
                      break;
                    case 5:
                       memory.T2b --;
                      break;
                    case 6:
                       memory.Nx --;
                      break;
                    default:
                      break; 
                    }
      }
  }
  else  TimingNewKey_dec = TimingDelay; 
  //
  
  //check_key  ֵΧ⣬ܳΧ
  if( memory.set_mode > 18 ) memory.set_mode  = 1 ;
  if( memory.set_mode < 1 ) memory.set_mode   = 18;
  
  if( memory.T1x > 999 ) memory.T1x = 1;
    if( memory.T1x < 1 ) memory.T1x = 999;
    
    if( memory.T1b > 999 ) memory.T1b = 1;
  if( memory.T1b < 1 ) memory.T1b = 999;
  
    if( memory.T2x > 999 ) memory.T2x = 1;
  if( memory.T2x < 1 ) memory.T2x = 999;
  
    if( memory.T2b > 999 ) memory.T2b = 1;
  if( memory.T2b < 1 ) memory.T2b = 999;
  
    if( memory.Nx > 999 ) memory.Nx = 1;
    if( memory.Nx < 1 ) memory.Nx = 999;

}

/*********************************
ܣ 
**********************************/
void main(void)
{
    CLK_DeInit();  
    CLK_HSIPrescalerConfig(CLK_PRESCALER_HSIDIV1); //    ʱӳʼ Ϊڲ16mhz /* Clock divider to HSI/1 */
    
    init_GPIO();        //ųʼ      
    Tim1_Init();        //ʱʼ
    FLASH_Config();     //洢FLASHʼ
    enableInterrupts(); //ж     
    Read_memory();      //
   

    while (1)
    {
       
        Play_data();            //ʾ 
        Play_key();             //ɨ谴
               
        //ǹģʽ
        if ( ! MODESET_OK )       Play_mode(); 
         //ģʽ 
        else                      Write_memory();  

        //̵״̬ʾ
        if(jdq_zhuangtai) led2_liang;
        else led2_mie;
        
        delay_ms(10);

    }
}


#ifdef USE_FULL_ASSERT

/**
  * @brief  Reports the name of the source file and the source line number
  *   where the assert_param error has occurred.
  * @param file: pointer to the source file name
  * @param line: assert_param error line source number
  * @retval : None
  */
void assert_failed(u8* file, u32 line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

  /* Infinite loop */
  while (1)
  {
  }
}
#endif

/******************* (C) COPYRIGHT 2011 STMicroelectronics *****END OF FILE****/
